﻿/// <reference path="~/m/js/Vevo.js" />
/// <reference path="~/m/js/Vevo.Objects.js" />
/// <reference path="~/m/js/Vevo.Views.Watch.js" />
var API = {
	AuthenticateVideo : function(authBase, isrc, domain, authToken, pKey, callback) {

		var fullUrl = authBase + "?isrc=" + isrc + "&domain=" + domain + "&authToken=FAB2ABBA-6EF1-4955-9588-3926DAEA9A3C";
		
		var newOptions = {
			url : fullUrl,
			success : function(data, status, xhr) {
				Vevo.Helpers.Console.Log("Callback Worked USING getJSON! JSON");
				Vevo.Helpers.Console.Log(data);
				var authResponse = new Vevo.Objects.AuthenticationItem.Clone(Vevo.Objects.AuthenticationItem);
				authResponse = Vevo.API.ParseAuthentication(data);
				Vevo.Repository.Videos.CacheAuthentication(isrc, authResponse);
				callback(authResponse);
			},
			dataType : "json"
		};
		$.ajax(newOptions.url, newOptions);
		// }
	},
	ParseAuthentication : function(data) {
		var authItem = new Vevo.Objects.AuthenticationItem.Clone(data);

		return authItem;
	},
	LoadVideo : function(isrc, onComplete) {
		var VIDEO_URL = 'http://vevo.com/data/video/' + isrc;
		var newOptions = {
			url : VIDEO_URL,
			dataType: "json",
			success : function(data, status, xhr) {
				console.log('#### Works');
				var video = new Vevo.Objects.VideoItem.Clone(Vevo.Objects.VideoItem);

				video = Vevo.API.ParseVideo(data, video);

				onComplete(video);
			},
			statusCode : {
				404 : function() {
					android.onError(3, textStatus, errorThrown);
				}
			},
			error : function(jqXHR, textStatus, errorThrown){
				android.onError(2, textStatus, errorThrown);
			}

		};
		$.ajax(newOptions.url, newOptions);
	},
	ParseVideo : function(data, objToFill) {
		var video = new Vevo.Objects.VideoItem.Clone(Vevo.Objects.VideoItem);
		if (objToFill != null) {
			video = objToFill;
		}
		video.ISRC = data.id;
		video.IsPremiere = data.isPremiere;
		video.Img = data.img;
		video.Title = data.title;
		video.Url = data.url;
		video.ViewCount = data.viewCount;
		video.ByArtistLinks = data.byline_links;
		video.IsExplicit = data.isExplicit;
		video.ShortUrl = data.shortUrl;
		video.Loaded = true;
		video.Copyright = data.copyright;
		video.TitleSafeName = data.titleSafename;

		// parse through main artists
		for ( var ix = 0, l = data.MainArtists.length; ix < l; ix++) {
			if (ix > 0)
				video.MainArtist.push([]);
			var item = data.MainArtists[ix];
			var target = new Vevo.Objects.Artist.Clone(Vevo.Objects.Artist);
			target.Img = item.img;
			target.Name = item.title;
			target.Url = item.url;
			target.ViewCount = item.viewCount;
			target.TodayRank = item.todayRank;
			target.WeekRank = item.weekRank;
			target.AllTimeRank = item.alltimeRank;
			target.ArtistSafeName = item.urlSafeName;
			target.BuyLinks = item.buyLinkUrls;
			video.MainArtist[ix] = target;
		}
		;
		// parse through the supporting artists
		for ( var ix = 0, l = data.Artists.length; ix < l; ix++) {
			if (ix > 0)
				video.SupportingArtists.push({});
			var item = data.Artists[ix];
			var target = video.SupportingArtists[ix];
			target.Img = item.img;
			target.Name = item.title;
			target.Url = item.url;
			target.ViewCount = item.viewCount;
			target.TodayRank = item.todayRank;
			target.WeekRank = item.weekRank;
			target.AllTimeRank = item.alltimeRank;
			target.BuyLinks = item.buyLinkUrls;
			target.ArtistSafeName = item.urlSafeName;
		}
		;
		// parse through video meta data, need to handle different casing
		// depending on the serialization
		data.VideoMetadata = data.videoMetadata ? data.videoMetadata : data.VideoMetadata;
		for ( var ix = 0, l = data.VideoMetadata.length; ix < l; ix++) {
			if (ix > 0)
				video.MetaData.push({});
			var item = data.VideoMetadata[ix];
			var target = video.MetaData[ix];
			target.MetaDataType = item.metadataType;
			target.Value = item.value;
		}
		;
		return video;
	},
	LoadNews : function(artistSafeName, onComplete, baseObj) {

		var newOptions = {
			url : '/data/news/' + artistSafeName,
			success : function(data, status, xhr) {
				var video = new Vevo.Objects.VideoItem.Clone(Vevo.Objects.VideoItem);
				if (baseObj != null && baseObj != undefined) {
					video = new Vevo.Objects.VideoItem.Clone(baseObj);
				}

				video.News.Loaded = true;
				video.News.ArtistName = data.artistSafeName;

				for ( var ix = 0, l = data.items.length; ix < l; ix++) {
					var item = data.items[ix];

					var target = new Vevo.Objects.NewsItem.Clone(Vevo.Objects.NewsItem);

					target.Body = item.Body;
					target.Date = item.Date;
					target.Title = item.Title;
					target.Url = item.Url;
					if (ix > 0)
						video.News.Items.push({});
					video.News.Items[ix] = target;
				}
				// Vevo.VideoView.RenderNews();
				onComplete(video);
			}
		};
		$.ajax(newOptions.url, newOptions);
	},
	LoadLyrics : function(isrc, onComplete, baseObj) {
		var newOptions = {
			url : '/data/VideoLyrics/' + isrc,
			success : function(data, status, xhr) {
				var video = new Vevo.Objects.VideoItem.Clone(Vevo.Objects.VideoItem);
				if (baseObj != null && baseObj != undefined) {
					video = new Vevo.Objects.VideoItem.Clone(baseObj);
				}
				video.Lyrics.Copyright = data.CopyRight;
				video.Lyrics.PixelTrackingURL = data.PixelTrackingUrl;
				video.Lyrics.Text = data.Text && '' != data.Text ? data.Text : data.CopyRight;
				video.Lyrics.Loaded = true;

				// Vevo.VideoView.RenderLyrics();
				onComplete(video);
			},
			error : function(jqXHR, textStatus, errorThrown) {
				var video = new Vevo.Objects.VideoItem.Clone(Vevo.Objects.VideoItem);
				if (baseObj != null && baseObj != undefined) {
					video = new Vevo.Objects.VideoItem.Clone(baseObj);
				}
				video.Lyrics.Text = Vevo.Resources.Lyrics_RatsDontHaveLyrics;
				video.Lyrics.Loaded = true;

				// Vevo.VideoView.RenderLyrics();
				onComplete(video);
			}
		};
		$.ajax(newOptions.url, newOptions);
	},
	LoadArtistInfo : function(artistSafeName, onComplete, baseObj) {
		newOptions = {
			url : '/data/artist/' + artistSafeName,
			success : function(data, status, xhr) {

				var video = new Vevo.Objects.VideoItem.Clone(Vevo.Objects.VideoItem);

				if (baseObj != null && baseObj != undefined) {
					video = new Vevo.Objects.VideoItem.Clone(baseObj);
				}

				video.MainArtist[0].TweeterID = data.TweeterID;
				video.MainArtist[0].Loaded = true;
				video.MainArtist[0].ArtistSafeName = data.artistSafeName;
				video.MainArtist[0].ViewCount = data.ViewCount;
				video.MainArtist[0].TodayRank = data.TodayRank;
				video.MainArtist[0].WeekRank = data.WeekRank;
				video.MainArtist[0].AllTimeRank = data.AllTimeRank;
				video.MainArtist[0].Links = data.Links;

				for ( var ix = 0, l = data.Links.length; ix < l; ix++) {
					var item = data.Links[ix];
					if (ix > 0)
						video.MainArtist[0].Links.push({});
					video.MainArtist[0].Links[ix].Url = item.Url;
					video.MainArtist[0].Links[ix].Text = item.Text;
				}
				;

				for ( var ix = 0, l = data.Tour.length; ix < l; ix++) {
					var item = data.Tour[ix];
					if (ix > 0)
						video.MainArtist[0].Tour.push({});
					video.MainArtist[0].Tour[ix].City = item.City;
					video.MainArtist[0].Tour[ix].Day = item.Day;
					video.MainArtist[0].Tour[ix].EventURL = item.EventURL;
					video.MainArtist[0].Tour[ix].Month = item.Month;
					video.MainArtist[0].Tour[ix].Venue = item.Venue;
				}
				;

				if (data.Tweets) {
					for ( var ix = 0, l = data.Tweets.length; ix < l; ix++) {
						var item = data.Tweets[ix];
						if (ix > 0)
							video.MainArtist[0].Tweets.push({});
						video.MainArtist[0].Tweets[ix].Text = item.Text;
						video.MainArtist[0].Tweets[ix].DateTime = item.DateTime;
					}
					;
				}

				if (data.Tour.length == 0) {
					video.MainArtist[0].Tour = [];
				}
				;
				if (data.Videos) {
					video.MainArtist[0].Videos = [ {} ];
					for ( var ix = 0, l = data.Videos.length; ix < l; ix++) {
						var item = data.Videos[ix];
						if (ix > 0)
							video.MainArtist[0].Videos.push({});
						video.MainArtist[0].Videos[ix].Title = item.title;
						video.MainArtist[0].Videos[ix].ByText = item.byline_text;
						video.MainArtist[0].Videos[ix].ImgSrc = item.img;
						video.MainArtist[0].Videos[ix].Isrc = item.id;
						video.MainArtist[0].Videos[ix].Url = item.url;
						video.MainArtist[0].Videos[ix].ViewCount = item.viewCount;
					}
					;
				}
				onComplete(video);
			}
		};
		$.ajax(newOptions.url, newOptions);
	},
	LoadArtistVideos : function(artistSafeName, offset, max, onComplete) {
		var newOptions = {
			url : 'http://api.vevo.com/mobile/v1/artist/' + artistSafeName + '/videos.json?offset=' + offset + '&max=' + max,
			success : function(data, status, xhr) {
				var videoList = [];
				if (data.result) {
					for ( var ix = 0, l = data.result.length; ix < l; ix++) {
						var item = data.result[ix];
						videoList.push({});
						videoList[ix].Title = item.title;
						var artistname = item.artists_main[0] == undefined ? "" : item.artists_main[0].name;
						videoList[ix].ByText = artistname;
						videoList[ix].ImgSrc = item.image_url;
						videoList[ix].Isrc = item.isrc;
						videoList[ix].Url = "/video/" + item.isrc;
						videoList[ix].ViewCount = Vevo.Helpers.insertCommasInNumber(item.viewcount);
					}
					;
				}
				onComplete(videoList);
			}
		};
		$.ajax(newOptions.url, newOptions);
	},
	ParsePlaylist : function(data, refPlaylist) {
		var playlist = new Vevo.Objects.Playlist.Clone(Vevo.Objects.Playlist);
		if (refPlaylist != null) {
			playlist = refPlaylist;
		}
		playlist.SessionID = data.ID;
		playlist.TypeOfPlaylist = data.Type;
		playlist.Name = data.Name;
		playlist.Loaded = true;
		playlist.Url = data.Url;
		playlist.ShortUrl = data.ShortUrl;
		playlist.OwnerID = data.OwnerID;
		playlist.OwnerName = data.OwnerName;
		if (data.Items && data.Items.length > 0) {
			for ( var ix = 0, l = data.Items.length; ix < l; ix++) {
				if (ix > 0)
					playlist.Items.push({});
				var video = Vevo.API.ParseVideo(data.Items[ix], null);
				playlist.Items[ix] = video;
				Vevo.Cache.Add(Vevo.Repository.Videos.CacheKey(video.ISRC), video);
			}
		}
		if (data.ISRCs && data.ISRCs != "") {
			playlist.Items = new Array();
			var items = data.ISRCs.split(',');
			items = _.uniq(items);
			for ( var ix = 0, l = items.length; ix < l; ix++) {
				var video = new Vevo.Objects.VideoItem.Clone(Vevo.Objects.VideoItem);
				video.ISRC = items[ix];
				playlist.Items.push(video);
			}
		}

		return playlist;
	},
	EchonestPlaylist : function(seedType, seedID, refPlaylist, onComplete) {
		var playlist = new Vevo.Objects.Playlist.Clone(Vevo.Objects.Playlist);
		if (refPlaylist != null) {
			playlist = refPlaylist;
		}

		var newOptions = {
			url : '/rec/newSession/' + seedType + '/' + seedID + '?t=' + Math.floor((Math.random() * 1000000) + 1),
			type : 'GET',
			data : {},
			success : function(data, status, xhr) {
				// parse the data returned from server
				playlist = Vevo.API.ParsePlaylist(data);

				if (onComplete) {
					onComplete(playlist);
				}
			}
		};
		$.ajax(newOptions.url, newOptions);
	},

	SavePlaylist : function(playlist, onComplete) {
		playlist = new Vevo.Objects.Playlist.Clone(playlist);
		var success = function(data) {
			// set playlist id
			playlist = Vevo.API.ParsePlaylist(data);

			if (onComplete) {
				onComplete(playlist);
			}
		};
		var playlistID = playlist.SessionID;
		if (playlist.TypeOfPlaylist == Vevo.Enums.PlaylistType.Echonest)
			playlistID = '';
		if (playlist.TypeOfPlaylist == Vevo.Enums.PlaylistType.Artist)
			playlistID = '';
		if (playlist.TypeOfPlaylist == Vevo.Enums.PlaylistType.Special)
			playlistID = '';
		if (playlist.SessionID != '' && (playlist.OwnerID != '' && playlist.OwnerID != Vevo.Environment.Context.UserID)) {
			// curent playlist doesn't belong to the user
			playlistID = '';
		}

		$.post('/UserPlaylistRest/Update', JSON.stringify({
			Title : playlist.Name,
			PlaylistID : playlistID,
			"IsPublic" : playlist.IsPublic,
			Description : '',
			Videos : playlist.ItemsAsISRC()
		}), success, 'json');
	},
	GetPlaylist : function(playlistID, onComplete) {
		var newOptions = {
			// url: '/UserPlaylistRest/Get',
			url : '/UserPlaylist/GetSingleUserPlaylist/' + playlistID,
			type : 'GET',
			// data: { 'playlistId': playlistID },
			success : function(data, status, xhr) {
				// parse the data returned from server
				playlist = Vevo.API.ParsePlaylist(data);

				if (onComplete) {
					onComplete(playlist);
				}
			}
		};
		$.ajax(newOptions.url, newOptions);
	},
	GetPlaylistByUserID : function(userID, onComplete) {
		var dataToSend = '';
		if (userID != null && userID != undefined) {
			dataToSend = {
				userId : userID
			};
		}
		var newOptions = {
			// url: '/UserPlaylistRest/Index',
			url : '/UserPlaylist/GetUserPlaylists',
			type : 'GET',
			data : dataToSend,
			success : function(data, status, xhr) {
				// console.log(data);
				// parse the data returned from server
				var toReturn = [];
				// for (var ix = items.length - 1, l = 0; l < ix; ix--) {
				for ( var ix = data.length - 1, l = 0; l < ix; ix--) {
					// for (var ix = 0, l = data.length; ix < l; ix++) {
					toReturn.push(Vevo.API.ParsePlaylist(data[ix]));
				}

				if (onComplete) {
					onComplete(toReturn);
				}
			}
		};
		$.ajax(newOptions.url, newOptions);
	},
	DeletePlaylist : function(playlistID, onComplete) {
		var newOptions = {
			url : '/UserPlaylistRest/Delete',
			type : 'GET',
			data : {
				'playlistId' : playlistID
			},
			success : function(data, status, xhr) {
				// parse the data returned from server
				// playlist = Vevo.API.ParsePlaylist(data);

				if (onComplete) {
					onComplete(data);
				}
			}
		};
		$.ajax(newOptions.url, newOptions);
	},
	GetArtistPlaylist : function(artistUrlSafeName, onComplete, orderByRecentVideos) {
		var newOptions = {
			url : '/artist/' + artistUrlSafeName,
			type : 'GET',
			data : {
				playlistId : artistUrlSafeName,
				orderByRecent : orderByRecentVideos,
				json : true
			},
			success : function(data, status, xhr) {
				// parse the data returned from server
				playlist = Vevo.API.ParsePlaylist(data);

				if (onComplete) {
					onComplete(playlist);
				}
			}
		};
		$.ajax(newOptions.url, newOptions);
	},
	GetArtistMixPlaylist : function(artistUrlSafeName, onComplete, orderByRecentVideos) {
		var newOptions = {
			url : '/artist-mix/' + artistUrlSafeName,
			type : 'GET',
			data : {
				playlistId : artistUrlSafeName,
				orderByRecent : orderByRecentVideos,
				json : true
			},
			success : function(data, status, xhr) {
				// parse the data returned from server
				playlist = Vevo.API.ParsePlaylist(data);

				if (onComplete) {
					onComplete(playlist);
				}
			}
		};
		$.ajax(newOptions.url, newOptions);
	},
	GetMostViewedVideoThisWeek : function(onComplete) {

		var newOptions = {
			url : 'http://api.vevo.com/mobile/v1/video/list.jsonp?order=mostviewedthisweek&genres=all-genres&offset=0&max=1',
			dataType : 'jsonp',
			type : 'GET',
			success : function(data, status, xhr) {
				// parse the data returned from server

				if (onComplete) {
					if (data && data.result && data.result.length > 0) {
						onComplete(data.result[0]);
					}
				}
			}
		};
		$.ajax(newOptions.url, newOptions);
	},
	GetLoggedInStatus : function(onComplete) {
		var newOptions = {
			url : '/account/GetLoggedInStatus?' + new Date().getTime(),
			type : 'GET',
			success : function(data, status, xhr) {
				if (onComplete) {
					onComplete(data);
				}
			}
		};
		$.ajax(newOptions.url, newOptions);
	},
	Login : function(onComplete) {
		$.ajax({
			url : '/account/login/',
			type : 'POST',
			data : 'userid=' + FB.getUserID() + '&accessToken=' + FB.getAccessToken(),
			success : function(data, status, xhr) {
				if (onComplete) {
					onComplete(data);
				}
			}
		});
	},
	Logout : function(onComplete) {
		$.ajax({
			url : '/account/logout/',
			type : 'POST',
			success : function(data, status, xhr) {
				if (onComplete) {
					onComplete(data);
				}
			}
		});
	},
	LastFm : function() {
		var authorize = function(sender) {
			if (sender.checked) {
				$.get("LastFmAuthorization").error(function(result) {
					sender.checked = false;
				}).success(function(lastfmlink) {
					window.location = lastfmlink;
				});
			} else {
				Vevo.Helpers.Cookies.remove("LastfmSession");
			}
		};
		var getSessionKey = function() {
			var result = 0;
			$.ajax("/Account/GetLastFmSessionKey", {
				timeout : 20000,
				async : false
			}).success(function(lastFmSessionKey) {
				result = lastFmSessionKey == "" ? 0 : lastFmSessionKey;
			});
			return result;
		};
		return {
			authorize : authorize,
			getSessionKey : getSessionKey
		};
	}(),
	SendInviteEmail : function(email1, email2, email3, message, playlistID, playlistName, playlistUrl, onComplete) {
		$.ajax({
			url : '/account/SendInvite/',
			type : 'POST',
			data : 'email1=' + email1 + '&email2=' + email2 + '&email3=' + email3 + '&message=' + message + '&playlistID=' + playlistID + '&playlistName='
					+ playlistName + '&playlistUrl=' + playlistUrl,
			success : function(data, status, xhr) {
				if (onComplete) {
					onComplete(data);
				}
			}
		});
	},
	SendInvite : function(accessToken, userID, friendID, onComplete) {
		$.ajax({
			url : apiBaseUrl + '/mobile/v1/user/SendFacebookInvite.json',
			type : 'POST',
			data : 'accessToken=' + accessToken + '&userID=' + userID + '&friendID=' + friendID,
			success : function(data, status, xhr) {
				if (onComplete) {
					onComplete(data);
				}
			}
		});
	},
	ReturnGetAllFriends : function(data, b) {

		if (data.result == undefined) {
			data = JSON.parse(data);
		}
		//
		// var combined = _.union(data.result.friends_not_on_vevo,
		// data.result.friends_on_vevo);
		var combined = data.result.friends_not_on_vevo;
		var onVevo = data.result.friends_on_vevo;
		var toReturn = [], vevoFriends = [];
		for ( var ix = 0, l = combined.length; ix < l; ix++) {
			var item = new Vevo.Objects.Friend.Clone(Vevo.Objects.Friend);
			var data = combined[ix];
			item.FacebookID = data.facebook_id;
			item.VevoID = data.vevo_id;
			item.Name = data.name;
			item.SentInvite = data.sent_invite;
			toReturn.push(item);
		}
		toReturn.sort(function(a, b) {
			return a.Name.toUpperCase().localeCompare(b.Name.toUpperCase());
		})

		for ( var ix = 0, l = onVevo.length; ix < l; ix++) {
			var item = new Vevo.Objects.Friend.Clone(Vevo.Objects.Friend);
			var data = onVevo[ix];
			item.FacebookID = data.facebook_id;
			item.VevoID = data.vevo_id;
			item.Name = data.name;
			item.SentInvite = data.sent_invite;
			vevoFriends.push(item);
		}
		vevoFriends.sort(function(a, b) {
			return a.Name.toUpperCase().localeCompare(b.Name.toUpperCase());
		})
		if (b.onComplete) {
			b.onComplete(toReturn, vevoFriends);
		}

	},
	GetAllFriends : function(accessToken, userID, onComplete) {

		if ($.browser.msie && window.XDomainRequest) {
			var b = {
				url : apiBaseUrl + "/mobile/v1/user/GetFacebookFriends.json?accessToken=" + accessToken + "&userID=" + userID,
				type : "POST",
				data : "accessToken=" + accessToken + "&userID=" + userID,
				onComplete : onComplete
			};

			Vevo.Repository.Helper.XDomainLoad(b, function(data, b) {
				Vevo.API.ReturnGetAllFriends(data, b);
			});
		} else {
			$.ajax({
				url : apiBaseUrl + '/mobile/v1/user/GetFacebookFriends.json',
				cache : false,
				type : 'POST',
				data : 'accessToken=' + accessToken + '&userID=' + userID,
				error : function(xhr, ajaxOptions, thrownError) {
				},
				success : function(data, status, xhr) {
					var b = {
						onComplete : onComplete
					};
					Vevo.API.ReturnGetAllFriends(data, b);
				}
			});
		}

	},
	Search : function(term, urlPrefix, onSuccess) {
		// / <summary>Performs a search against the API</summary>
		// / <param name="term" type="string">Search term</param>
		// / <param name="urlPrefix" type="string">Use either lookahead or
		// search(does a lucine search)</param>
		// / <param name="onSuccess" type="function">To be executed at the end
		// of successfull operation</param>

		// this is a hack i know. but it must be done
		var baseUrl = searchBaseUrl;
		if (urlPrefix == 'search')
			baseUrl = apiBaseUrl;

		if ($.browser.msie && window.XDomainRequest) {
			// Use Microsoft XDR
			var xdr = new XDomainRequest();
			xdr.open("get", baseUrl + "/mobile/v1/" + urlPrefix + ".json?q=" + term + "&fullItems=true&newSearch=yes");
			xdr.onload = function() {
				// parse response as JSON
				var JSON = $.parseJSON(xdr.responseText);
				if (JSON == null || typeof (JSON) == 'undefined') {
					JSON = $.parseJSON(data.firstChild.textContent);
				}
				onSuccess(JSON);
			};
			xdr.send();
		} else {

			var params = {
				url : baseUrl + "/mobile/v1/" + urlPrefix + ".json",
				data : {
					q : term,
					fullItems : true,
					newSearch : 'yes'
				},
				cache : true,
				error : function(jqXHR, textStatus, errorThrown) {
					Vevo.Helpers.Console.Log('Error on Search');
					Vevo.Helpers.Console.Log(jqXHR);
					Vevo.Helpers.Console.Log(textStatus);
					Vevo.Helpers.Console.Log(errorThrown);
				},

				beforeSend : function(jqXHR, settings) {
					timeStart = new Date().getTime();
				},
				complete : function(jqXHR, textStatus) {
					var timeEnd = new Date().getTime();
					// Vevo.Helpers.Console.Log(timeEnd + ' - ' + timeStart);
					Vevo.Helpers.Console.Log(timeEnd - timeStart);
					var gaLocation = Vevo.Environment.Context.PageName == Vevo.Enums.PageType.Home ? 'home' : 'header';
					// log the time taken to get the data, only for chrome as
					// its timing are about ~20ms of
					if (navigator.userAgent.indexOf("Chrome/18") > -1) {
						Vevo.Helpers.Console.Log('Loging Timing');
						_gaq.push([ '_trackEvent', gaLocation, 'time-taken', 'search', timeEnd - timeStart, true ])
					}

					Vevo.Helpers.Console.Log(textStatus);
					// Vevo.Helpers.Console.Log(jqXHR);
					VevoTemp = jqXHR;
					if (textStatus == 'success') {
						retryCount = 0;
					} else {
						Vevo.Helpers.Console.Log('retryCount:' + retryCount);
						// increment failed searches
						_gaq.push([ '_trackEvent', gaLocation, 'search-retry', 'try-' + retryCount, 1, true ])
						retryCount++;
						if (retryCount < 3) {
							$.ajax(this);
						}
					}

				},
				success : onSuccess
			}
			if ($.browser.msie && $.browser.version == 7.0) {
				params.url = baseUrl + "/mobile/v1/" + urlPrefix + ".jsonp";
				params.dataType = "jsonp";
				params.jsonpCallback = "cb";
				params.jsonp = "cb";

			}

			$.ajax(params);

		}
		;
	}
};
// 0485c511-690f-4f7e-8881-481f429c0722

// Test for JSONP callback
cb = function(data) {
	Vevo.Helpers.Console.Log("Callback Worked!");
	Vevo.Helpers.Console.Log(data);
}

// ///extend vevo object
var tmp = $.extend(false, Vevo.API, API);
Vevo.API = tmp;
API = null;
