﻿Vevo.Temp = function () {
	this.sessionMonitoringAttempted = false;
	this.livePassInitialized = false;
	this.sessionCleaned = true;
	this.livePassNotifier = function (convivaNotification) {
		if (convivaNotification.code == 0) {
			Vevo.Helper.Console.Log("Conviva LivePass initialized successfully.");
		} else {
			if (Conviva.LivePass.ready) { // check if LivePass is already initialized
				Vevo.Helper.Console.Log("Conviva LivePass post-initialization feedback.\n " +
                         "\tCode: " + convivaNotification.code + ";\n " +
                         "\tMessage: " + convivaNotification.message);
			} else {
				Vevo.Helper.Console.Log("Conviva LivePass failed to initialize!\n " +
                           "t\Conviva metrics will not be captured! " +
                           "\tCode: " + convivaNotification.code + "; " +
                           "\tMessage: " + convivaNotification.message);
			}
		}
	};
	this.getGrouping = function (a, p) {

		var r = [];

		for (var i = 0; i < a.length; i++) {
			r.push(a[i][p]);
		}

		return r.join();
	};
	this.beginSessionMonitoring = function () {
		if (typeof Conviva !== "undefined" && Conviva) {
			var isrc = Vevo.Views.Watch.authData.video.isrc;
			var artistSafeName = Vevo.Views.Watch.authData.video.urlSafeArtistName;
			var title = Vevo.Views.Watch.authData.video.urlSafetitle;
			var assetName = isrc + " - " + artistSafeName + " - " + title;
			var url = Vevo.Helpers.GetHTML5Video(Vevo.Views.Watch.authData);
			var na = "N/A";
			var video = Vevo.Views.Watch.authData.video;
			var convivaMetadata = Conviva.ConvivaContentInfo.createInfoForLightSession(assetName);


			var mainArtists = na;
			if (video.mainArtists && video.mainArtists != undefined && video.mainArtists.length > 0) { mainArtists = Vevo.HTML5.Conviva.getGrouping(video.mainArtists, "artistName") };

			var featuredArtists = na;
			if (video.featuredArtists && video.featuredArtists != undefined && video.featuredArtists.length > 0) { featuredArtists = Vevo.HTML5.Conviva.getGrouping(video.featuredArtists, "artistName") };


			convivaMetadata.streamUrl = url;
			convivaMetadata.isLive = false;
			convivaMetadata.cdnName = "LEVEL3";
			convivaMetadata.playerName = "HTML5 Mobile";
			convivaMetadata.deviceType = Conviva.ConvivaContentInfo.DEVICE_TYPE_MOBILE;
			convivaMetadata.tags = {
				isrc: isrc,
				albumId: video.albumId || na,
				albumName: video.albumName || na,
				contentDuration: video.duration,
				composer: video.composer || na,
				director: video.director || na,
				genre: video.genres.join(),
				featuredArtists: featuredArtists,
				isExplicit: video.isExplicit,
				isMonetizable: video.isMonetizable,
				isPremiere: video.isPremiere,
				mainArtists: mainArtists,
				pageUrl: video.deepLinkUrl,
				recordLabel: video.recordLabel || na,
				shortUrlId: video.shortUrlId,
				releaseDate: video.releaseDate,
				title: video.title || na,
				urlSafetitle: video.urlSafetitle,
				urlSafeArtistName: video.urlSafeArtistName,
				domain: window.location.hostname
			}

			var streamer = $('#videoPlayer')[0];
			if (!Vevo.HTML5.Conviva.sessionCleaned) {
				Vevo.HTML5.Conviva.cleanupSession();
			}
			var session = Conviva.LivePass.createSession(streamer, convivaMetadata);
			session.setContentLength(video.duration);

			Vevo.HTML5.Conviva.sessionCleaned = false;
			streamer.onended = Vevo.HTML5.Conviva.endSessionMonitoring;
		}
	};

	this.endSessionMonitoring = function () {
		Vevo.HTML5.Conviva.cleanupSession();
	};
	this.cleanupSession = function () {

		if (typeof Conviva !== "undefined" && Conviva) {
			var streamer = $('#videoPlayer')[0];
			Conviva.LivePass.cleanupMonitoringSession(streamer);
			Vevo.HTML5.Conviva.sessionCleaned = true;
		}
	}
};

Vevo.Temp =
{
	Conviva: new Vevo.Temp()
}
///extend vevo object
var tmp = $.extend(false, Vevo.HTML5, Vevo.Temp);
Vevo.HTML5 = tmp;
Vevo.Temp = null;