﻿/// <reference path="~/m/js/Vevo.js" />
/// <reference path="~/m/js/Vevo.Enums.js" />
Vevo.Objects = {
	AuthenticationItem: {
		video: {
			isrc: '',
			title: '',
			urlSafetitle: '',
			urlSafeArtistName: '',
			imageUrl: '',
			contentProviderId: 0,
			youTubeId: '',
			description: '',
			deepLinkUrl: '',
			shortUrlId: '',
			isMonetizeable: false,
			isPremiere: false,
			isCertified: false,
			allowEmbed: false,
			duration: 0,
			releaseDate: new Date(),
			hasLyrics: false,
			featuredArtists: [{
				artistId: '',
				artistName: '',
				urlSafeArtistName: '',
				imageUrl: '',
				enabled: false,
				buylinks: [{ linkType: '', vendor: '', url: ''}]
			}],

			mainArtists: [{
				artistId: '',
				artistName: '',
				urlSafeArtistName: '',
				imageUrl: '',
				enabled: false,
				buylinks: [{ linkType: '', vendor: '', url: ''}]
			}],
			buylinks: [{ linkType: '', vendor: '', url: ''}],
			videoVersions: [{ version: 0, sourceType: 0, id: '', data: ''}],
			metadata: [{ keyType: '', keyIndex: 0, keyValue: ''}],
			copyrightLine: '',
			genres: [''],
			isExplicit: false,
			isFacebookWatch: false
		},
		errorInfo: { ytid: '' },
		isApproved: false,
		isMonetizeable: false,
		statusMessage: '',
		statusDetails: '',
		statusCode: 0,
		countryCode: '',
		Clone: function (obj) {
			this.video = obj.video;
			this.errorInfo = obj.errorInfo;
			this.isApproved = obj.isApproved;
			this.isMonetizeable = obj.isMonetizeable;
			this.statusMessage = obj.statusMessage;
			this.statusDetails = obj.statusDetails;
			this.statusCode = obj.statusCode;
			this.countryCode = obj.countryCode;
			this.isrc = obj.isrc;
			this.title = obj.title;
			this.urlSafeTitle = obj.urlSafeTitle;
			this.imageUrl = obj.imageUrl;
			this.contentProviderId = obj.contentProviderId;
			this.youTubeId = obj.youTubeId;
			this.description = obj.description;
			this.deepLinkUrl = obj.deepLinkUrl;
			this.shortUrlId = obj.shortUrlId;
			this.isPremiere = obj.isPremiere;
			this.allowEmbed = obj.allowEmbed;
			this.duration = obj.duration;
			this.releaseDate = obj.releaseDate;
			this.hasLyrics = obj.hasLyrics;
			this.copyrightLine = obj.copyrightLine;
			this.isExplicit = obj.isExplicit;
			this.countryCode = obj.countryCode;
			return this;
		}
	},
	Artist: {
		Img: 'path',
		Name: '',
		Url: '',
		TweeterID: '',
		Loaded: false,
		ArtistSafeName: '',
		Tour: [{ Month: '1', Day: '31', City: 'None', Venue: 'None', EventURL: 'None'}],
		ViewCount: 1,
		TodayRank: 1,
		WeekRank: 1,
		AllTimeRank: 1,
		Links: [{ Url: '', Text: ''}],
		Tweets: [{ Text: '', DateTime: ''}],
		Videos: [{ Title: '', ByText: '', ImgSrc: '', ViewCount: '', Isrc: '', Url: ''}],
		Clone: function (obj) {
			this.Img = obj.Img;
			this.ArtistSafeName = obj.ArtistSafeName;
			this.Name = obj.Name;
			this.LastTweet = obj.LastTweet;
			this.LastTweetDT = obj.LastTweetDT;
			this.Loaded = obj.Loaded;
			this.Name = obj.Name;
			this.Url = obj.Url;
			this.ViewCount = obj.ViewCount;
			this.TodayRank = obj.TodayRank;
			this.WeekRank = obj.WeekRank;
			this.AllTimeRank = obj.AllTimeRank;
			this.BuyLinks = obj.BuyLinks;
			this.TweeterID = obj.TweeterID;
			this.Videos = obj.Videos;

			this.Tour = [{ Month: '1', Day: '31', City: 'None', Venue: 'None', EventURL: 'None'}];
			this.Links = [{ Url: '', Text: ''}];
			this.Tweets = [{ Text: '', DateTime: ''}];

			for (var ix = 0, l = obj.Tweets.length; ix < l; ix++) {
				if (ix > 0) this.Tweets.push({});
				this.Tweets[ix].Text = obj.Tweets[ix].Text;
				this.Tweets[ix].DateTime = obj.Tweets[ix].DateTime;
			}

			for (var ix = 0, l = obj.Links.length; ix < l; ix++) {
				if (ix > 0) this.Links.push({});
				this.Links[ix].Text = obj.Links[ix].Text;
				this.Links[ix].Url = obj.Links[ix].Url;
			}

			for (var ix = 0, l = obj.Tour.length; ix < l; ix++) {
				if (ix > 0) this.Tour.push({});
				this.Tour[ix].Month = obj.Tour[ix].Month;
				this.Tour[ix].Day = obj.Tour[ix].Day;
				this.Tour[ix].City = obj.Tour[ix].City;
				this.Tour[ix].Venue = obj.Tour[ix].Venue;
				this.Tour[ix].EventURL = obj.Tour[ix].EventURL;
			}
			return this;
		}
	},
	NewsItem: {
		Title: '',
		Body: '',
		Url: '',
		Date: '',
		Clone: function (obj) {
			this.Title = obj.Title;
			this.Body = obj.Body;
			this.Url = obj.Url;
			this.Date = obj.Date;
			return this;
		}
	},
	CarouselItem: {
		Url: '',
		Title: '',
		Subtitle: '',
		Body: '',
		IsPremiere: false,
		Img: '',
		HeaderImg: '',
		AdContentId: '',
		Clone: function (obj) {
			this.Url = obj.Url;
			this.Title = obj.Title;
			this.Subtitle = obj.Subtitle;
			this.Body = obj.Body;
			this.IsPremiere = obj.IsPremiere;
			this.Img = obj.Img;
			this.HeaderImg = obj.HeaderImg;
			this.AdContentUrl = obj.AdContentUrl;
			return this;
		}
	},
	Friend: {
		FacebookID: '',
		VevoID: '',
		SentInvite: false,
		Name: '',
		Clone: function (obj) {
			this.FacebookID = obj.FacebookID;
			this.VevoID = obj.VevoID;
			this.SentInvite = obj.SentInvite;
			this.Name = obj.Name;
			return this;
		}
	},
	ArtistNews: [],
	VideoItem: [],
	Playlist: []
}

Vevo.Objects.ArtistNews ={
	Loaded:false,
	ArtistName:'', 
	Items:[new Vevo.Objects.NewsItem.Clone(Vevo.Objects.NewsItem)],
	Clone:function(obj){
		this.Loaded = obj.Loaded;
		this.ArtistName = obj.ArtistName;
		this.Items = [new Vevo.Objects.NewsItem.Clone(Vevo.Objects.NewsItem)]


		for (var ix = 0, l = obj.Items.length; ix < l; ix++) {
			if (ix > 0) this.Items.push({});
			this.Items[ix] = new Vevo.Objects.NewsItem.Clone(obj.Items[ix]);
		}
		return this;
	}
}

Vevo.Objects.VideoItem = {
	CacheKey: '',
	ISRC: '',
	Title: 'Song Title',
	ViewCount: 1,
	Url: '',
	Img: '',
	IsPremiere: false,
	IsCertified: false,
	ByArtistLinks: '',
	MainArtist: [new Vevo.Objects.Artist.Clone(Vevo.Objects.Artist)],
	SupportingArtists: [new Vevo.Objects.Artist.Clone(Vevo.Objects.Artist)],
	News: new Vevo.Objects.ArtistNews.Clone(Vevo.Objects.ArtistNews),
	MetaData: [{ MetaDataType: '', Value: ''}],
	Lyrics: {
		Copyright: '',
		PixelTrackingURL: '',
		Text: '',
		Loaded: false
	},
	IsExplicit: false,
	ShortUrl: '',
	Loaded: false,
	Copyright: '',
	Clone: function (obj) {
		if (typeof obj == "string") {
			return obj; //isrc only
		}
		this.ISRC = obj.ISRC;
		this.Title = obj.Title;
		this.ViewCount = obj.ViewCount;
		this.Url = obj.Url;
		this.IsPremiere = obj.IsPremiere;
		this.IsCertified = obj.IsCertified;
		this.ByArtistLinks = obj.ByArtistLinks;
		this.Img = obj.Img;

		//		if (obj.MainArtist[0].Loaded){
		//			this.MainArtist = [];
		//		}else{
		//			this.MainArtist = [new Vevo.Objects.Artist.Clone(Vevo.Objects.Artist)]
		//		};
		this.MainArtist = [new Vevo.Objects.Artist.Clone(Vevo.Objects.Artist)];
		for (var ix = 0, l = obj.MainArtist.length; ix < l; ix++) {
			if (ix > 0) this.MainArtist.push({});
			this.MainArtist[ix] = new Vevo.Objects.Artist.Clone(obj.MainArtist[ix]);
		}
		this.SupportingArtists = obj.SupportingArtists;
		this.News = new Vevo.Objects.ArtistNews.Clone(obj.News);

		//this.MetaData = obj.MetaData;
		this.MetaData = [{ MetaDataType: '', Value: ''}];
		for (var ix = 0, l = obj.MetaData.length; ix < l; ix++) {
			if (ix > 0) this.MetaData.push({});
			this.MetaData[ix].MetaDataType = obj.MetaData[ix].MetaDataType;
			this.MetaData[ix].Value = obj.MetaData[ix].Value;
		}

		this.Lyrics = obj.Lyrics;
		this.IsExplicit = obj.IsExplicit;
		this.ShortUrl = obj.ShortUrl;
		this.Loaded = obj.Loaded;
		this.Copyright = obj.Copyright;
		return this;
	}
}

/////extend vevo object
//var tmp = $.extend(false, Vevo.Objects, Vevo.Temp);
//Vevo.Objects = tmp;
//VevoObjects = null;
//Vevo.Objects.VideoItem.MainArtist[0]

Vevo.Objects.Playlist = {
	Name: '',
	Index: 0,
	SessionID: 0,
	Items: [new Vevo.Objects.VideoItem.Clone(Vevo.Objects.VideoItem)],
	TypeOfPlaylist: Vevo.Enums.PlaylistType,
	Loaded: false,
	Url: '',
	ShortUrl: '',
	IsPublic: true,
	OwnerID: '',
	OwnerName: '',
	ItemsAsISRC: function () {
		var toReturn = []
		for (var ix = 0, l = this.Items.length; ix < l; ix++) {
			if (this.Items[ix].ISRC != '') {
				toReturn.push(this.Items[ix].ISRC);
			}
		}
		toReturn = _.uniq(toReturn);
		return toReturn;
	},
	GetIndexByISRC: function (isrc) {
		for (var ix = 0; ix < this.Items.length; ix++) {
			if (Vevo.Objects.Playlist.GetISRC(this.Items[ix]) == isrc) return ix;
		}
		return -1;
	},
	GetISRC: function (videoItem) {
		var isrc = typeof videoItem == "string" ? videoItem : videoItem.ISRC;
		return isrc;
	},
	Clone: function (obj) {
		this.SessionID = obj.SessionID;
		this.Name = obj.Name;
		this.Index = obj.Index;

		if (obj.Items.length > 0 && typeof obj.Items[0] != "string") {
			this.Items = [new Vevo.Objects.VideoItem.Clone(Vevo.Objects.VideoItem)]
			for (var ix = 0, l = obj.Items.length; ix < l; ix++) {
				if (ix > 0) this.Items.push({});
				if (typeof obj.Items[ix] == "string") {
					this.Items[ix] = obj.Items[ix];
				} else {
					this.Items[ix] = new Vevo.Objects.VideoItem.Clone(obj.Items[ix]);
				}
				

			}
		} else {
			this.Items = obj.Items;
		}

		this.ItemsAsISRC = Vevo.Objects.Playlist.ItemsAsISRC;
		this.GetIndexByISRC = Vevo.Objects.Playlist.GetIndexByISRC;
		this.TypeOfPlaylist = obj.TypeOfPlaylist;
		this.Loaded = obj.Loaded;
		this.Url = obj.Url;
		this.ShortUrl = obj.ShortUrl;
		if (obj.IsPublic != undefined) {
			this.IsPublic = obj.IsPublic;
		} else {
			this.IsPublic = true;
		}
		this.OwnerID = obj.OwnerID;
		this.OwnerName = obj.OwnerName;

		return this;
	}

}

/////add playlist to the Vevo.Objects
////this is done this way, cause Playlist contains a collection of VideoItem 
////and it can't be refrenced within the same structure
//var tmp = $.extend(false, Vevo.Objects.Playlist, Playlist);
//Vevo.Objects.Playlist = tmp;
//VevoObjects = null;

function logImpression(val){
	Vevo.Helpers.Console.Log(val);
}


