﻿Vevo.Temp = function() {
	var trackingState = {};

	this.tab1Activated = false;
	this.tab2Activated = false;
	this.tab3Activated = false;
	this.tab4Activated = false;
	this.Playlist = null;
	this.CurIndex = 0;
	this.CurrentVideo = null;
	this.ArtistLoaded = false;
	this.ArtistVideosOffset = 0;
	this.FirstTimePlaying = true;
	this.fwSiteSection = "";
	this.authData = {};
	this.ForcePlayed = false;
	this.HandleAuthCallback = function(authItem) {
		Vevo.Helpers.Console.Log("handleAuthCallback");
		Vevo.Views.Watch.authData = authItem;
		var playerContainer = $("#playerHTML5");
		if (!authItem.isApproved) {
			android.onError(1, authItem.statusMessage, authItem.statusDetails);
		} else {

			// load video source and freewheel ad
			var siteSectionId = Vevo.Views.Watch.fwSiteSection;
			$('#videoPlayer')[0].src = Vevo.Helpers.GetHTML5Video(authItem);

			// start tracking
			setupStreamTrackingForvideo(trackingState.video, trackingState.trackAsNewPage);

			if (Vevo.Views.Watch.FirstTimePlaying) { // must initialize play
				// through click
				Vevo.HTML5.Freewheel.init(siteSectionId, function() {
					// set video ready to play
					if ($("#videoPlayer").css("display") == "block") {
						return;
					}
					$("#loadingImg").hide();

					$("#playerImg").show();
					playerContainer.unbind('click').click(function() {
						playerContainer.unbind('click');
						$("#playerImg").hide(0, function() {
						});

						if (android.showAdvertisement()) {
							Vevo.HTML5.Freewheel.playPreRoll();
						}
						Vevo.Views.Watch.InitPlayVideo();
					});
				});
			} else {
				Vevo.HTML5.Freewheel.init(siteSectionId, function() {
					if (android.showAdvertisement()) {
						Vevo.HTML5.Freewheel.playPreRoll();
					}
					Vevo.Views.Watch.InitPlayVideo();
				});
			}

			if (Vevo.Helpers.Cookies.get('IsSocialOn') != 'False') {
				Vevo.Facebook.OGMusic.Video.publish('http://www.vevo.com/video' + Vevo.Views.Watch.CurrentVideo.ISRC);
			}
		}
	};
	this.InitPlayVideo = function() {
		var playerContainer = $("#playerHTML5");
		var video = Vevo.Views.Watch.CurrentVideo;
		playerContainer.css("background", "none");
		playerContainer.css("background-color", "black");

		$("#videoPlayer").show();
		$("#videoPlayer").css("display", "inline");

		document.getElementById("videoPlayer").play();
		$("#loadingImg").show();
		Vevo.Views.Watch.ForcePlayed = true;
	};

	var setupStreamTrackingForvideo = function(video, trackAsNewPage) {
		if (typeof ss1 != 'undefined' && ss1 && video) {
			var all_artists = [];
			if (video.MainArtist) {
				for ( var x = 0; x < video.MainArtist.length; x++) {
					all_artists.push(video.MainArtist[x].ArtistSafeName);
				}
			}

			var programTitle = '';
			var playlistTitle = '';

			$.each(video.MetaData, function(idx, item) {
				switch (item.MetaDataType) {
				case 33:
					playlistTitle = item.Value;
					break;

				case 34:
					programTitle = item.Value;
					break;
				}
			});

			var mainArtistSafeName = (video.MainArtist && video.MainArtist.length > 0) ? video.MainArtist[0].ArtistSafeName : "";

			var attributes = {
				video_id : video.ISRC,
				ns_st_ci : video.ISRC,
				video_artist : mainArtistSafeName,
				all_artist : all_artists.join('|'),
				video_playback_location : 'mobile web',
				loc_url : window.location.href,
				loc_site : 'vevo',
				ns_type : 'hidden',
				player_ver : 'progressive'
			};

			// todo : get the other types
			if (video.IsPremiere) {
				attributes['video_content_type'] = "premiere";
			}

			if (Vevo.playerId) {
				attributes['syn_id'] = Vevo.playerId;
			}

			ss1.setAttributes(attributes);

			var playlist = ss1.getPlaylist();
			if (playlist) {
				playlist.setAttribute("playlistTitle", playlistTitle);
			}

			var clip = ss1.getClip();
			if (clip) {
				clip.setAttribute("programTitle", programTitle);
				clip.setAttribute("episodeTitle", video.TitleSafeName);
				clip.setAttribute("type", 'vod');
			}

			// setup the new page load
			if (trackAsNewPage) {
				var trackingObj = {
					name : 'watch.' + mainArtistSafeName + '.' + video.TitleSafeName + '.' + video.ISRC,
					content_title : video.TitleSafeName,
					content_id : video.ISRC,
					artists : mainArtistSafeName
				};

				Vevo.Tracking.ComScore.trackPageLoad(trackingObj);
			}
		}
	}

	this.SetCurrentVideo = function(video, trackAsNewPage) {
		// update the page

		document.title = video.Title + ' - ' + video.MainArtist[0].Name;

		// setup tracking state
		trackingState.video = video;
		trackingState.trackAsNewPage = trackAsNewPage;

		this.CurrentVideo = video;
		Vevo.Views.Watch.ForcePlayed = false;
		// set poster image to fill
		var posterImg = video.Img;

		posterImg += "?crop=auto&height=" + $(window).height() + "&width=" + $(window).width();

		// initialize video player
		var playerContainer = $("#playerHTML5");
		playerContainer.css("background", "url(" + posterImg + ") center center no-repeat");
		$("#videoPlayer").attr("poster", posterImg);
		Vevo.Views.Watch.StartingShowPlayer = false;

		var authUrl = playerContainer.attr('data-authurl');
		Vevo.Repository.Videos.Authenticate(authUrl, video.ISRC, "www.vevo.com", null, null, Vevo.Views.Watch.HandleAuthCallback);

		Vevo.Views.Watch.ArtistLoaded = false;
	};

	this.OnVideoEnded = function(event) {
		Vevo.Helpers.Analytics.trackEvent("VideoPlayerHtml5", "PlaybackEnded", Vevo.HTML5.Freewheel.theVideoAssetId);

		android.onVideoEnded();

		// if (!Vevo.HTML5.Freewheel.preRollPlaying) {
		// Vevo.Views.Watch.PlayNextVideo();
		// }
	};

	this.StartingShowPlayer = false;
	this.OnVideoPlaying = function(event) {
		if (!Vevo.Views.Watch.StartingShowPlayer) {
			var playerContainer = $("#playerHTML5");
			$("#playerImg").hide();
			$("#playerImgLight").hide();
			$("#loadingImg").hide();
			$("#videoPlayer").css("margin-top", "0px");
			playerContainer.css("background", "none");
			playerContainer.css("background-color", "black");
			$("#videoPlayer").css("display", "inline");
			Vevo.Views.Watch.StartingShowPlayer = true;
			Vevo.HTML5.Conviva.beginSessionMonitoring();
			var video = Vevo.Views.Watch.CurrentVideo;
			Vevo.Helpers.Analytics.trackEvent("VideoPlayerHtml5", "PlaybackBegin", Vevo.HTML5.Freewheel.theVideoAssetId);
			Vevo.Helpers.Analytics
					.trackSuperBeacon("e1f36bdf-761c-435a-8fa0-432e39a6f019", Vevo.HTML5.Freewheel.theVideoAssetId, "0", "www.vevo.com", "", "US");
			Vevo.Tracking.ComScore.trackComScore("1", "3005647", "", video.MainArtist != null && video.MainArtist.length > 0 ? video.MainArtist[0].Name : "",
					"02", "");

			// todo : solomon : add tracking here
			// watch.' + video.MainArtist[0].ArtistSafeName + '.' +
			// video.TitleSafeName + '.' + video.ISRC

			if (!Vevo.Views.Watch.ForcePlayed) {
				Vevo.HTML5.Freewheel.playPreRoll();
			}
		}
		if (Vevo.HTML5.Freewheel.preRollPlaying) {
			$(".ad-notification").show();
		} else {
			$(".ad-notification").hide();
		}
	};
	this.OnVideoPause = function(event) {
		$(".ad-notification").hide();
	};
	this.OnVideoReady = function(event) {
		document.getElementById("videoPlayer").play();
		Vevo.HTML5.Conviva.beginSessionMonitoring();

		var video = Vevo.Views.Watch.CurrentVideo;
		Vevo.Helpers.Analytics.trackEvent("VideoPlayerHtml5", "PlaybackBegin", Vevo.HTML5.Freewheel.theVideoAssetId);
		Vevo.Helpers.Analytics.trackSuperBeacon("e1f36bdf-761c-435a-8fa0-432e39a6f019", Vevo.HTML5.Freewheel.theVideoAssetId, "0", "www.vevo.com", "", "en-US");
		Vevo.Tracking.ComScore.trackComScore("1", "3005647", "", video.MainArtist != null && video.MainArtist.length > 0 ? video.MainArtist[0].Name : "", "02",
				"");
	};
	this.SetUpcomingVideo = function(isrc, index) {
		Vevo.Repository.Videos.Get(isrc, $.proxy(function(videoData) {
			var upcomingVideo = $(".upcoming-video");
			$("img", upcomingVideo).attr("src", videoData.Img + "?width=270&height=152&crop=auto");
			var views = videoData.ViewCount == "1" ? "view" : "views";
			$(".upcoming-title", upcomingVideo).html(
					videoData.Title + " - " + videoData.MainArtist[0].Name + "<br/>" + videoData.ViewCount + " " + Vevo.Resources.Watch_LowerViews);
			$("#upcoming-video-a").attr("href", "#" + index);

			upcomingVideo.delay(1000).slideDown('400');
		}));
	};
	this.PlayNextVideo = function() {
		var videoToPlayIndex = $("#upcoming-video-a").attr("href");
		videoToPlayIndex = parseInt(videoToPlayIndex.substr(1));
		Vevo.Views.Watch.CurIndex = videoToPlayIndex;
		Vevo.Views.Watch.FirstTimePlaying = false;
		$("#videoPlayer").attr("src", "");
		document.getElementById("videoPlayer").pause();
		Vevo.Repository.Videos.Get(Vevo.Views.Watch.Playlist.Items[videoToPlayIndex].ISRC, $.proxy(function(item) {
			Vevo.Views.Watch.SetCurrentVideo(item, true);
		}));

		// set video data
		Vevo.Views.Watch.tab1Activated = false;
		Vevo.Views.Watch.tab2Activated = false;
		Vevo.Views.Watch.tab3Activated = false;
		Vevo.Views.Watch.ActivateTab($("#videoTab1")); // artist videos

		// set upcoming video
		$(".upcoming-video").hide();
		if (videoToPlayIndex < Vevo.Views.Watch.Playlist.Items.length - 1) {
			Vevo.Views.Watch.SetUpcomingVideo(Vevo.Views.Watch.Playlist.Items[videoToPlayIndex + 1].ISRC, videoToPlayIndex + 1);
		} else { // retrieve new playlist
			Vevo.Repository.Playlist.Echonest(Vevo.Views.Watch.CurrentVideo.ISRC, null, $.proxy(function(playlist) {
				Vevo.Views.Watch.Playlist = playlist;
				Vevo.Views.Watch.CurIndex = 0;
				Vevo.Views.Watch.SetUpcomingVideo(playlist.Items[1].ISRC, 1);
			}, this));
		}
	};
	this.ParsePlaylistForUpcomingVideo = function(playlistData) {
		if (playlistData && playlistData.ISRCs) {
			var isrcs = playlistData.ISRCs.split(",");
			if (isrcs.length > 1) {
				var newOptions = {
					url : '/data/video/' + isrcs[1],
					success : function(data, status, xhr) {
						if (data) {
							Vevo.Views.Watch.SetUpcomingVideo(data);
						}
					}
				};
				$.ajax(newOptions.url, newOptions);
			}
		}
	};
	this.RetrieveSessionPlaylist = function(seedType, seedValue) {
		// set upcoming video
		var newOptions = {
			url : "/rec/newSession/" + seedType + "/" + seedValue,
			type : 'GET',
			data : {},
			success : function(data, status, xhr) {
				// parse the data returned from server
				// playlist = Vevo.API.ParsePlaylist(data);
				Vevo.Views.Watch.ParsePlaylistForUpcomingVideo(data);
			}
		};
		$.ajax(newOptions.url, newOptions);
	};

	this.ActivateTab = function($tab) {
		var $activeTab = $tab.closest('dl').find('a.active'), contentLocation = "#" + $tab.attr("id") + 'Tab';

		// Make Tab Active
		$activeTab.removeClass('active');
		$tab.closest('dd').find('a').addClass('active');

		if ($tab.attr("id") == "videoTab1") { // artist videos
			if (!this.tab1Activated) {
				if (Vevo.Views.Watch.ArtistLoaded) {
					$("#vevo-video-list").html("");
					Vevo.Views.Watch.ArtistVideosOffset = 0;
					Vevo.Views.Watch.ArtistVideosLoaded(Vevo.Views.Watch.CurrentVideo.MainArtist[0].Videos);
					Vevo.Views.Watch.tab1Activated = true;
				} else {
					var artistSafeName = $("#artistSafename").val();
					$("#vevo-video-list").html("");
					Vevo.Views.Watch.ArtistVideosOffset = 0;
					Vevo.API.LoadArtistVideos(artistSafeName, 0, 20, function(item) {
						Vevo.Views.Watch.ArtistVideosLoaded(item);

						Vevo.Views.Watch.tab1Activated = true;
					}, this.CurrentVideo);
				}
			}
		} else if ($tab.attr("id") == "videoTab2") { // bio

			Vevo.Helpers.Analytics.trackEvent('watch_page', 'sidebar', 'artist_bio');
			Vevo.Tracking.ComScore.trackImageDaxComScore({
				"watch_page_events" : "bio"
			});

			if (!this.tab2Activated) {
				if (Vevo.Views.Watch.ArtistLoaded) {
					Vevo.Views.Watch.ArtistBioLoaded(contentLocation, Vevo.Views.Watch.CurrentVideo.MainArtist[0]);
					Vevo.Views.Watch.tab2Activated = true;
				} else {
					var artistSafeName = $("#artistSafename").val();
					Vevo.Repository.Artist.Get(artistSafeName, function(item) {
						Vevo.Views.Watch.CurrentVideo = item;
						Vevo.Views.Watch.ArtistLoaded = true;
						Vevo.Views.Watch.ArtistBioLoaded(contentLocation, item.MainArtist[0]);
					}, this.CurrentVideo);
				}
			}
		} else if ($tab.attr("id") == "videoTab3") { // lyrics
			Vevo.Helpers.Analytics.trackEvent('watch_page', 'sidebar', 'lyrics');
			if (!this.tab3Activated) {
				Vevo.API.LoadLyrics($("#videoIsrc").val(), function(video) {
					Vevo.Views.Watch.tab2Activated = true;
					var lyrics = video.Lyrics;
					$(contentLocation).html(
							((lyrics.Copyright != lyrics.Text ? lyrics.Text + '<p>' + lyrics.Copyright + '</p>' : lyrics.Text) || '').replace(/\n/gi,
									'<br /> \n'));
				});
			}
		} else if ($tab.attr("id") == "videoTab4") { // video info
			Vevo.Helpers.Analytics.trackEvent('watch_page', 'sidebar', 'video_info');
			Vevo.Tracking.ComScore.trackImageDaxComScore({
				"watch_page_events" : "video_info"
			});

			if (!this.tab4Activated) {
				// get video if the video info data is not loaded yet
				if (this.CurrentVideo.MetaData.length == 0 || this.CurrentVideo.MainArtist[0].Name == "") {
					// get video
					Vevo.Repository.Videos.Get(this.CurrentVideo.ISRC, function(item) {
						Vevo.Views.Watch.CurrentVideo = item;
						Vevo.Views.Watch.RenderVideoInfo(contentLocation);
					});
				} else {
					Vevo.Views.Watch.RenderVideoInfo(contentLocation);
				}
			}
		}

		// Show Tab Content
		$(contentLocation).closest('.tabs-content').children('li').hide();
		$(contentLocation).show();
	};
	this.RenderVideoInfo = function(contentLocation) {
		var video = this.CurrentVideo, hasDirector = false, hasProducer = false, hasComposer = false, hasEditor = false, hasRecordLabel = false, hasGenre = false, hasSubgenre = false, hasAlbum = false, hasTimePeriod = false, copyright = '';

		var sb = new $.StringBuilder();

		sb.append('<p><strong>' + Vevo.Resources.Watch_PrimaryArtist + '</strong><br/>');
		sb.append('<a href="/artist/' + video.MainArtist[0].ArtistSafeName + '">' + video.MainArtist[0].Name + '</a>');
		sb.append('</p>');

		for ( var ix = 0, l = video.MetaData.length; ix < l; ix++) {
			var meta = video.MetaData[ix];
			switch (meta.MetaDataType) {
			case 1: // producer
				hasProducer = true;
				break;
			case 2: // director
				hasDirector = true;
				break;
			case 3: // composer
				hasComposer = true;
				break;
			case 6: // genre
				hasGenre = true;
				break;
			case 7: // label
				hasRecordLabel = true;
				break;
			case 8: // editor
				hasEditor = true;
				break;
			case 9: // album
				hasAlbum = true;
				break;
			case 11: // time period
				hasTimePeriod = true;
				break;
			case 12: // copyright
				copyright = meta.Value;
				break;
			case 14: // subgenre
				hasSubgenre = true;
				break;
			}
		}
		sb.append(this._renderSongMetaData(video.MetaData, 2, Vevo.Resources.Watch_Director, hasDirector));
		sb.append(this._renderSongMetaData(video.MetaData, 1, Vevo.Resources.Watch_Producer, hasProducer));
		sb.append(this._renderSongMetaData(video.MetaData, 3, Vevo.Resources.Watch_Composer, hasComposer));
		sb.append(this._renderSongMetaData(video.MetaData, 8, Vevo.Resources.Watch_Editor, hasEditor));
		sb.append(this._renderSongMetaData(video.MetaData, 9, Vevo.Resources.Watch_Album, hasAlbum));
		sb.append(this._renderSongMetaData(video.MetaData, 11, Vevo.Resources.Watch_TimePeriod, hasTimePeriod));
		sb.append(this._renderSongMetaData(video.MetaData, 7, Vevo.Resources.Watch_RecordLabel, hasRecordLabel));
		sb.append(this._renderSongMetaData(video.MetaData, 6, Vevo.Resources.Watch_Genre, hasGenre));
		sb.append(this._renderSongMetaData(video.MetaData, 14, Vevo.Resources.Watch_Subgenre, hasSubgenre));

		copyright = copyright == '' ? video.Copyright : copyright;

		sb.append('<br />');
		sb.append('<p>' + copyright + '</p>');

		$(contentLocation).html(sb.toString());
	};
	this.ArtistBioLoaded = function(contentLocation, mainArtist) {
		$.ajax({
			url : 'http://apikr7d.echonest.com/api/v4/artist/biographies?api_key=KR7D834N7JWG7ZWHT&name=' + $("#artistSafename").val().replace(/-/gi, "+")
					+ '&format=jsonp&results=1&start=0&license=cc-by-sa',
			dataType : 'jsonp',
			success : function(r) {
				if (r.response.status && r.response.status.message == 'Success' && r.response.biographies.length > 0 && r.response.biographies[0].text) {
					Vevo.Views.Watch.tab3Activated = true;
					$(contentLocation).html("");
					$(contentLocation).append(r.response.biographies[0].text);
					if (mainArtist.Links && mainArtist.Links.length > 0) {
						var sb = new $.StringBuilder();
						sb.append('<br/><br/><dl class="nice vertical tabs">');
						for ( var i = 0, l = mainArtist.Links.length; i < l; i++) {
							if (mainArtist.Links[i].Url && mainArtist.Links[i].Text && mainArtist.Links[i].Url != '' && mainArtist.Links[i].Text != '') {
								sb.append('<dd class="artist-buy-links"><a href="' + mainArtist.Links[i].Url + '" target="_blank">' + mainArtist.Links[i].Text
										+ '</a></dd>');
							}
						}
						sb.append('</dl></div>');
						$(contentLocation).append(sb.toString());
					}
				}
			}
		});
	};
	this.ArtistVideosLoaded = function(artistVideos) {

		// image resize param
		var imageResizeParam = "";
		if ($(window).width() >= 768) {
			imageResizeParam = "?width=286&height=160&crop=auto";
		} else {
			imageResizeParam = "?width=160&height=90&crop=auto";
		}

		for ( var i = 0; i < artistVideos.length; i++) {
			var video = artistVideos[i];
			var views = video.ViewCount == 1 ? "view" : "views";
			var html = "<dd><a href='/video/" + video.Isrc
					+ "' cs_name='watch_page_events' cs_val='video_select' class='comscorelink'><div class='video-list-details'>" + "<img src='" + video.ImgSrc
					+ imageResizeParam + "'>" + "<div class='video-info'><p class='song-title'>" + video.Title + "</p>" + "<p class='song-artist'>"
					+ video.ByText + "</p>" + "<p class='song-views'>" + video.ViewCount + " " + Vevo.Resources.Watch_Views + "</p>"
					+ "</div><div class='clear'></div></div></a></dd>";
			$("#vevo-video-list").append(html);
		}
		Vevo.Views.Watch.ArtistVideosOffset += artistVideos.length;

		// in some cases we will load the last 20 videos and there will be no
		// more, but we don't know how many videos there are before loading them
		if (artistVideos.length == 20) {
			$("#vevo-video-list").append("<dd id='loadMoreVideos' class='load-more tablet-full-width'><a>" + Vevo.Resources.Watch_LoadMore + "</a></dd>");
			$("#loadMoreVideos").unbind('click').click(function() {
				$("#loadMoreVideos").remove();
				Vevo.API.LoadArtistVideos($("#artistSafename").val(), Vevo.Views.Watch.ArtistVideosOffset, 20, function(item) {
					Vevo.Views.Watch.ArtistVideosLoaded(item);
				});
			});
		}
	};
	this._renderSongMetaData = function(metadata, metaDataType, label, exists) {
		var sb = new $.StringBuilder();
		if (exists) {
			sb.append('<p><strong>' + label + ': </strong><br/>');
			var iFound = 0;
			for ( var ix = 0, l = metadata.length; ix < l; ix++) {
				if (metadata[ix].MetaDataType == metaDataType) {
					if (iFound > 0)
						sb.append(', ');
					sb.append(metadata[ix].Value);
					iFound++;
				}
			}
			sb.append('</p>');
		}
		return sb.toString();
	};
	this.InitPlaylist = function(playlist, index) {
		playlist.Index = index;
		this.Playlist = playlist;
		Vevo.Views.Watch.CurIndex = index;
		Vevo.Repository.Videos.Get(playlist.Items[index].ISRC, $.proxy(function(item) {
			playlist.Items[playlist.Index] = item;
			Vevo.Views.Watch.CurIndex = playlist.Index;
			Vevo.Views.Watch.SetCurrentVideo(item);
		}, this));

		if (index < playlist.Items.length - 1) {
			this.SetUpcomingVideo(playlist.Items[index + 1].ISRC, index + 1);
		} else {
			this.SetUpcomingVideo(playlist.Items[0].ISRC, 0);
		}
	};

	this.Init = function(isrc, playlistID, playlistType, playlistData, fwSiteSection, options) {
		Conviva.LivePass.init("http://livepass.conviva.com", "c3.Vevo", Vevo.HTML5.Conviva.livePassNotifier);
		Vevo.Views.Watch.fwSiteSection = fwSiteSection;
		Vevo.Environment.Context.PageName = Vevo.Enums.PageType.Watch;

		if (options && options.heightOverride) {
			$(".player-container").css("height", options.heightOverride + "px");
		}

		// if (playlistData == null) { // single video
		Vevo.Repository.Videos.Get(isrc, $.proxy(function(item) {
			Vevo.Views.Watch.SetCurrentVideo(item);
		}, this));
		// }

		// player events
		$('#videoPlayer').click(function() {
			if (document.getElementById('videoPlayer').paused) {
				document.getElementById('videoPlayer').play();
				$('#playerImg').hide();
			} else {
				document.getElementById('videoPlayer').pause();
				$('#playerImg').show();
			}
		});

		$('#playerImg').click(function() {
			document.getElementById('videoPlayer').play();
			$('#playerImg').hide();
		});

		$('#videoPlayer').bind('ended', Vevo.Views.Watch.OnVideoEnded);
		$('#videoPlayer').bind('timeupdate', Vevo.Views.Watch.OnVideoPlaying);
		$('#videoPlayer').bind('pause', Vevo.Views.Watch.OnVideoPause);
		$("#loadingImg").show();
	};
}

Vevo.Temp = {
	Watch : new Vevo.Temp()
}

// /extend vevo object
var tmp = $.extend(false, Vevo.Views, Vevo.Temp);
Vevo.Views = tmp;
Vevo.Temp = null;
